commit 540c0c7c424a43c1d99dd22f6db020cc0cd6eaea
Author: Uros Bizjak <ubizjak@gmail.com>
Date:   Mon Nov 18 22:38:46 2024 +0100

    i386: Enable *rsqrtsf2_sse without TARGET_SSE_MATH [PR117357]
    
    __builtin_ia32_rsqrtsf2 expander generates UNSPEC_RSQRT insn pattern
    also when TARGET_SSE_MATH is not set.  Enable *rsqrtsf2_sse without
    TARGET_SSE_MATH to avoid ICE with unrecognizable insn.
    
            PR target/117357
    
    gcc/ChangeLog:
    
            * config/i386/i386.md (*rsqrtsf2_sse):
            Also enable for !TARGET_SSE_MATH.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/i386/pr117357.c: New test.
    
    (cherry picked from commit 344356f781ddb7bf0abb11edf9bdd13f6802dea8)

diff --git a/gcc/testsuite/gcc.target/i386/pr117357.c b/gcc/testsuite/gcc.target/i386/pr117357.c
new file mode 100644
index 00000000000..7a27691a977
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr117357.c
@@ -0,0 +1,7 @@
+/* { dg-do compile } */
+/* { dg-options "-msse -mfpmath=387" } */
+
+float foo (float f)
+{
+  return __builtin_ia32_rsqrtf (f);
+}

